using System;
using System.Collections.Generic;
class ConsoleApp1
{
    static void PrikaziListu(List<int> lista)
    {
        Console.Write("Lista: ");
        foreach (var element in lista)
        {
            Console.Write(element + " ");
        }
        Console.WriteLine();
    }
    static List<int> IzbrisiElemente(List<int> lista, int l, int r)
    {
        if (l < 0 || r >= lista.Count || l > r)
        {
            return null;
        }
        List<int> novaLista = new List<int>(lista);
        
        novaLista.RemoveRange(l, r - l + 1);
        return novaLista;
    }
    static int MinZbir(List<int> lista)
    {
        int n = lista.Count;
        if (n == 0) return 0;
        if (n == 1) return lista[0];
        

        int[] dp = new int[n];

        dp[0] = lista[0];
        dp[1] = lista[1];

        for (int i = 2; i < n; i++)
        {
            dp[i] = lista[i] + Math.Min(dp[i - 1], dp[i - 2]);
        }

        return Math.Min(dp[n - 1], dp[n - 2]);
    }
    static void Main(string[] args)
    {
        int n = int.Parse(Console.ReadLine());
        string[] s = Console.ReadLine().Split(' ');

        List<int> niz = new List<int>();
        

        for (int i = 0; i < n; i++)
        {
            niz.Add(int.Parse(s[i]));
        }

        int q = int.Parse(Console.ReadLine());
        int[] l = new int[q];
        int[] r = new int[q];
        
        int[] rezultat = new int[q];
        for (int i = 0; i < q; i++)
        {
            string[] d = Console.ReadLine().Split(' ');
            l[i] = int.Parse(d[0]) - 1;
            r[i] = int.Parse(d[1]) - 1;
            List<int> novalista = new List<int>(IzbrisiElemente(niz, l[i], r[i]));

            rezultat[i] = MinZbir(novalista);
           
        }

        for(int i = 0; i < q;i++)
        {
            Console.WriteLine(rezultat[i]);
        }


    }
}