#include<bits/stdc++.h>

using namespace std;

const int maxn=5e5+10;

vector<int> g[maxn];
int p[maxn];
int b[maxn];
int siz[maxn];
int kum[maxn];
int depth[maxn];
int vel[maxn];

vector<pair<int,int> > hld[maxn];
vector<int> lanac[maxn];


void dfs(int node=1,int d=0){
  siz[node]=1;
  depth[node]=d;
  pair<int,int> maxi={-1,-1};
  if(kum[node]==0) kum[node]=kum[p[node]];
  for(int i:g[node]){
    dfs(i,d+1);
    maxi=max(maxi,{siz[i],i});
    siz[node]+=siz[i];
  }
  for(int i:g[node]){
    if(i==maxi.second) continue;
    kum[i]=i;
  }
}

void dfs2(int node=1){
  lanac[kum[node]].push_back(node);
  for(int i:g[node]){
    dfs2(i);
  }
}

void update(vector<pair<int,int> > &segt,int t,int val,int ind=1,int l=0,int r=-1){
  if(r==-1) r=int(segt.size())-1;
  if(l==r){
    segt[ind]={val,-l};
    return;
  }
  int mid=l+(r-l)/2;
  if(t<=mid) update(segt,t,val,2*ind,l,mid);
  else update(segt,t,val,2*ind+1,mid+1,r);
  segt[ind]=max(segt[2*ind],segt[2*ind+1]);
}

void update(int node,int val){
  int cale=kum[node];
  int lik=depth[node]-depth[cale];
  update(hld[cale],lik,val);
}

pair<int,int> query(vector<pair<int,int> > &segt,int tl,int tr,int ind=1,int l=0,int r=-1){
  if(r==-1) r=int(segt.size())-1;
  if(tl<=l && r<=tr) return segt[ind];
  int mid=l+(r-l)/2;
  pair<int,int> maxi={0,0};
  if(tl<=mid) maxi=max(maxi,query(segt,tl,tr,2*ind,l,mid));
  if(tr>mid) maxi=max(maxi,query(segt,tl,tr,2*ind+1,mid+1,r));
  return maxi;
}

int sled(int node,int snaga){
  if(depth[node]+1<=snaga) return 0;
  int naj=-1;
  int poc=depth[node];
  while(node!=0){
    int cale=kum[node];
    if(poc-snaga<=depth[cale]){
      pair<int,int> nes=hld[cale][1];
      if(nes.first==1) naj=lanac[cale][-nes.second];
    }else{
      int tr=depth[node]-depth[cale];
      int tl=poc-snaga-depth[cale];
      if(tl>tr) break;
      pair<int,int> nes=query(hld[cale],tl,tr);
      if(nes.first==1) naj=lanac[cale][-nes.second];
      break;
    }
    node=p[cale];
  }
  if(depth[naj]==poc) return -1;
  return naj;
}

int main(){
  ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
  int n; cin>>n;
  for(int i=0;i<n-1;i++){
    int u,v; cin>>u>>v;
    p[v]=u;
    g[u].push_back(v);
  }
  kum[1]=1; dfs(); dfs(); dfs2();
  for(int i=1;i<=n;i++) vel[kum[i]]++;
  for(int i=1;i<=n;i++) hld[i].resize(4*vel[i]+10,{0,0});
  for(int i=1;i<=n;i++){
    cin>>b[i];
    if(b[i]==1) update(i,1);
  }
  for(int i=1;i<=n;i++){
    int x; cin>>x;
    if(x!=0){
      update(x,b[x]^1);
      b[x]^=1;
    }
    int node=i;
    int res=0;
    int snaga=i;
    while(node!=0){
      res++;
      node=sled(node,snaga);
      if(node==-1){
        res=-1;
        break;
      }
    }
    cout<<res<<" ";
  }
  return 0;
}