using System;
using System.Linq;

class Program
{
    static int CalculateBeauty(int[][] matrix, int K, int L)
    {
        int maxBeauty = 0;
        for (int i = 0; i <= matrix.Length - K; i++)
        {
            for (int j = 0; j <= matrix[0].Length - L; j++)
            {
                int submatrixSum = matrix.Skip(i).Take(K)
                    .SelectMany(row => row.Skip(j).Take(L))
                    .Sum();
                int beauty = submatrixSum;
                maxBeauty = Math.Max(maxBeauty, beauty);
            }
        }
        return maxBeauty;
    }

    static void Main()
    {
        int[] dimensions = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int N = dimensions[0];
        int M = dimensions[1];
        int K = dimensions[2];
        int L = dimensions[3];

        int[] A = Console.ReadLine().Split().Select(int.Parse).ToArray();

        int[][] matrix = new int[N][];
        for (int i = 0; i < N; i++)
        {
            matrix[i] = A.Skip(i * M).Take(M).ToArray();
        }
        int result = CalculateBeauty(matrix, K, L);
        Console.WriteLine(result);
    }
}