#include <stdio.h>
#include <math.h>

int minimumListe(int duzina, long int lista[], int koristeni[])
{
    int minimumIndeks;

    minimumIndeks = 0;
    
    while(koristeni[minimumIndeks]!=0) minimumIndeks++;

    for(int i = 1; i<duzina; i++)
    {
        if(lista[i]<lista[minimumIndeks] && koristeni[i] == 0) minimumIndeks = i;
    }

    return minimumIndeks;
}

void dijkstraAlg(int brojCvorova, int brojIvica, long int (*ivice)[3])
{
    long int probnoRastojanje[brojCvorova];

    probnoRastojanje[0] = 0;
    
    for(int i = 1; i<brojCvorova; i++)
    {
        probnoRastojanje[i] = INFINITY;
    }

    int trenutniCvor;

    int poseceniCvorovi[brojCvorova];

    long int predlog;

    for(int i = 0; i < brojCvorova; i++) poseceniCvorovi[i] = 0;

    while(poseceniCvorovi[brojCvorova-1]!=1)
    {
        trenutniCvor = minimumListe(brojCvorova, probnoRastojanje, poseceniCvorovi);
        for(int i = 0; i<brojIvica; i++) if(ivice[i][0] == trenutniCvor)
        {
            predlog = probnoRastojanje[trenutniCvor] + ivice[i][2];
            if(predlog < probnoRastojanje[ivice[i][1]]) probnoRastojanje[ivice[i][1]] = predlog;
        }
    
        poseceniCvorovi[trenutniCvor] = 1;
    }

    printf("%d\n", probnoRastojanje[brojCvorova-1]);

    
}

int main()
{
    int n;

    scanf("%d", &n);

    long int tezine[n+2];

    tezine[0] = 0;
    tezine[n+1] = 0;
    for(int i = 1; i<n+1; i++) scanf("%d", &tezine[i]);
    
    int q;
    scanf("%d", &q);

    int preskakanja[q][2];

    for(int i = 0; i<q; i++) scanf("%d%d", &preskakanja[i][0], &preskakanja[i][1]);

    long int ivice[2*n+4][3];

    for(int i = 0; i<n; i++)
    {
        ivice[2*i][0] = i;
        ivice[2*i+1][0] = i;
        ivice[2*i][1] = i+1;
        ivice[2*i][2] = tezine[i];
        ivice[2*i+1][1] = i+2;
        ivice[2*i+1][2] = tezine[i];
    }

    ivice[2*n][0] = n;
    ivice[2*n][1] = n+1;
    ivice[2*n][2] = tezine[n];

    for(int i = 0; i<q; i++){
        ivice[2*n+1][0] = preskakanja[i][0]-1;
        ivice[2*n+1][1] = preskakanja[i][1]+1;
        ivice[2*n+1][2] = tezine[preskakanja[i][0]-1];
        ivice[2*n+2][0] = preskakanja[i][0]-1;
        ivice[2*n+2][1] = preskakanja[i][1]+2;
        ivice[2*n+2][2] = tezine[preskakanja[i][0]-1];
        ivice[2*n+3][0] = preskakanja[i][0]-2;
        ivice[2*n+3][1] = preskakanja[i][1]+1;
        ivice[2*n+3][2] = tezine[preskakanja[i][0]-2];
        dijkstraAlg(n+2, 2*n+4, ivice);
    }
    


}