def max_beauty_dynamic(N, M, K, L, A):
    prefix_sum = [0] * (N * M + 1)

    for i in range(1, N * M + 1):
        prefix_sum[i] = prefix_sum[i - 1] + A[i - 1]

    max_beauty = [[0] * (M - L + 2) for _ in range(N - K + 2)]

    for i in range(1, N - K + 2):
        for j in range(1, M - L + 2):
            submatrix_sum = prefix_sum[i * M + j + K * M - 1] - prefix_sum[i * M + j - 1] \
                             - prefix_sum[(i + K) * M + j + K * M - 1] + prefix_sum[(i + K) * M + j - 1]
            max_beauty[i][j] = max_beauty[i - 1][j] + max_beauty[i][j - 1] - max_beauty[i - 1][j - 1] + submatrix_sum

    return max_beauty[N - K + 1][M - L + 1]


N, M, K, L = map(int, input().split())
A = list(map(int, input().split()))

result = max_beauty_dynamic(N, M, K, L, A)
print(result)