#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    int N, Q;
    int broj, M, J;
    std::vector<long> snage;

    // Unos podataka

    cin >> N;

    for (int i=0; i<N; i++){
        cin >> broj;
        snage.push_back(broj);
    }

    cin >> Q;
    std::vector<vector<long>> zamene(Q, std::vector<long>(2, 0));

    for (int i=0; i<Q; i++){
        cin >> M >> J;
        zamene[i][0] = M;
        zamene[i][1] = J;
    }

    // Logika

    for (int i=0; i<Q; i++){

        std::vector<long> pom_snage(snage);

        long miljenik = zamene[i][0];
        long broj_zamena = zamene[i][1];

        auto minSnaga = std::min_element(pom_snage.begin(), pom_snage.end());
        auto maxSnaga = std::max_element(pom_snage.begin(), pom_snage.end());

        if (*minSnaga == pom_snage[miljenik-1]) {
            cout << 1 << endl;
            continue;
        } else if (*maxSnaga == pom_snage[miljenik-1]) {
            cout << log2(pom_snage.size())+1 << endl;
            continue;
        };

        int broj_krugova = 0;
        while (pom_snage.size()>1) {
            std::vector<vector<long>> krug(pom_snage.size()/2, std::vector<long>(2, 0));

            int adresa_miljenika;
            int pozicija_miljenika;
            int pozicija_za_zamenu;
            bool miljenik_pobedio = false;

            for (int i=0; i<(pom_snage.size()/2); i++){
                krug[i][0] = pom_snage[i*2];
                krug[i][1] = pom_snage[i*2 + 1];

                if (pom_snage[miljenik-1] == krug[i][0]){
                        adresa_miljenika = i;
                        pozicija_miljenika = 0;
                        pozicija_za_zamenu = 1;

                        if (krug[i][0] > krug[i][1]) {
                            miljenik_pobedio = true;
                        }

                } else if (pom_snage[miljenik-1] == krug[i][1]){
                        adresa_miljenika = i;
                        pozicija_miljenika = 1;
                        pozicija_za_zamenu = 0;

                        if (krug[i][1] > krug[i][0]) {
                            miljenik_pobedio = true;
                        }
                }

            }

            broj_krugova += 1;

            if (!miljenik_pobedio) {

                // probaj zamenu

                if (broj_zamena > 0) {

                        broj_zamena--;

                        auto minSnaga = std::min_element(pom_snage.begin(), pom_snage.end());

                        for (int j=0; j<pom_snage.size()/2; j++) {
                            if (krug[j][0] == *minSnaga) {
                                int pom = krug[j][0];
                                krug[j][0] = krug[adresa_miljenika][pozicija_za_zamenu];
                                krug[adresa_miljenika][pozicija_za_zamenu] = pom;
                                break;
                            }
                        }

                }

                        if (krug[adresa_miljenika][pozicija_za_zamenu] > krug[adresa_miljenika][pozicija_miljenika]) {
                            pom_snage.clear();
                            continue;
                        } else {
                            pom_snage.clear();
                            for (int m=0; m<krug.size(); m++) {

                                if (krug[m][0] > krug[m][1]) {
                                    pom_snage.push_back(krug[m][0]);
                                } else {
                                    pom_snage.push_back(krug[m][1]);
                                }
                            }
                        }

            } else {

                        if (krug[adresa_miljenika][pozicija_za_zamenu] > krug[adresa_miljenika][pozicija_miljenika]) {
                            pom_snage.clear();
                            continue;;
                        } else {
                                pom_snage.clear();
                                for (int m=0; m<krug.size(); m++) {

                                    if (krug[m][0] > krug[m][1]) {
                                        pom_snage.push_back(krug[m][0]);
                                    } else {
                                        pom_snage.push_back(krug[m][1]);
                                    }
                                }
                        }
            }
        }

        if (broj_krugova == 0) {
            broj_krugova++;
        }

        cout << broj_krugova << endl;

    }

    return 0;
}