#include <iostream>
#include <bitset>

constexpr int N_MAX = 500'000;

int n;
std::bitset<N_MAX> pristupacnost;
int veze[N_MAX];
int promene[N_MAX];

int main(int argc, char const *argv[])
{
    std::ios_base::sync_with_stdio(false);
    
    for (int i = 0; i < n; i++)
    {
        veze[i] = -1;
    }
    
    std::cin >> n;
    
    for (int i = 0, u, v; i < n - 1; i++)
    {
        std::cin >> u >> v;
        veze[v - 1] = u - 1;
    }

    for (int i = 0; i < n; i++)
    {
        bool p;
        std::cin >> p;
        pristupacnost[i] = p;
    }

    for (int i = 0, promena; i < n; i++)
    {
        std::cin >> promena;
        promene[i] = promena - 1;
    }

    std::cout << 1;

    if (promene[0] != -1)
    {
        pristupacnost[promene[0]] = !pristupacnost[promene[0]];
    }

    for (int i = 1; i < n; i++)
    {
        if (promene[i] != -1)
        {
            pristupacnost[promene[i]] = !pristupacnost[promene[i]];
        }

        int broj_skokova = 0;
        bool brk = false;
        int trenutna_soba, zadrzana = i;

        while (!brk)
        {
            broj_skokova++;
            trenutna_soba = zadrzana;
            int stara_zadrzana = zadrzana;
            
            for (int j = 1; j <= i; j++)
            {
                trenutna_soba = veze[trenutna_soba];

                if (trenutna_soba == -1 || trenutna_soba == 0)
                {
                    std::cout << ' ' << broj_skokova;
                    brk = true;
                    break;
                }

                if (pristupacnost[trenutna_soba])
                {
                    zadrzana = trenutna_soba;
                }
            }

            if (brk)
            {
                break;
            }

            if (zadrzana == stara_zadrzana)
            {
                std::cout << ' ' << -1;
                break;
            }
        }
    }
}