#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9,MOD=1e9+7;
const ll LINF=1e18;
#define fi first
#define se second
#define pii pair<int,int>
#define mid ((l+r)/2)
#define sz(a) (int((a).size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define pb push_back

void PRINT(int x) {cerr << x;}
void PRINT(ll x) {cerr << x;}
void PRINT(double x) {cerr << x;}
void PRINT(char x) {cerr << '\'' << x << '\'';}
void PRINT(string x) {cerr << '\"' << x << '\"';}
void PRINT(bool x) {cerr << (x ? "true" : "false");}

template<typename T,typename V>
void PRINT(pair<T,V>& x){
    cerr<<"{";
    PRINT(x.fi);
    cerr<<",";
    PRINT(x.se);
    cerr<<"}";
}
template<typename T>
void PRINT(T &x){
    int id=0;
    cerr<<"{";
    for(auto _i:x){
        cerr<<(id++ ? "," : "");
        PRINT(_i);
    }
    cerr<<"}";
}
void _PRINT(){
    cerr<<"]\n";
}
template<typename Head,typename... Tail>
void _PRINT(Head h,Tail... t){
    PRINT(h);
    if(sizeof...(t)) cerr<<", ";
    _PRINT(t...);
}

#define Debug(x...) cerr<<"["<<#x<<"]=["; _PRINT(x)

const int mxN=2e5;

struct Node{
    ll s,s00,s01,s10,s11;
};

void Merge2(Node& n,Node& n1,Node& n2){
    n.s00=min(n1.s00+n2.s10,n1.s01+min(n2.s00,n2.s10));
    n.s01=min(n1.s00+n2.s11,n1.s01+min(n2.s01,n2.s11));
    n.s11=min(n1.s11+min(n2.s01,n2.s11),n1.s10+n2.s11);
    n.s10=min(n1.s11+min(n2.s00,n2.s10),n1.s10+n2.s10);
    n.s=min({n.s00,n.s01,n.s10,n.s11});
}

void Merge1(Node& n1,Node& n2){
    ll s00=min(n1.s00+n2.s10,n1.s01+min(n2.s00,n2.s10));
    ll s01=min(n1.s00+n2.s11,n1.s01+min(n2.s01,n2.s11));
    ll s11=min(n1.s11+min(n2.s01,n2.s11),n1.s10+n2.s11);
    ll s10=min(n1.s11+min(n2.s00,n2.s10),n1.s10+n2.s10);
    ll s=min({n1.s00,n1.s01,n1.s10,n1.s11});
    n1={s,s00,s01,s10,s11};
}

ll a[mxN+1];
Node seg[4*mxN+1];

void Init(int node,int l,int r){
    if(l==r){
        seg[node].s11=a[l];
        seg[node].s00=0;
        seg[node].s10=seg[node].s01=LINF;
        return;
    }
    Init(2*node,l,mid); Init(2*node+1,mid+1,r);
    Merge2(seg[node],seg[2*node],seg[2*node+1]);
}

Node Query(int node,int l,int r,int L,int R){
    if(L>R) return {0,0,LINF,LINF,LINF};
    if(L<=l && r<=R) return seg[node];
    Node ret;
    if(L<=mid){
        ret=Query(2*node,l,mid,L,R);
        if(R>mid){
            Node qv=Query(2*node+1,mid+1,r,L,R);
            Merge1(ret,qv);
        }
    }
    else{
        if(R>mid) ret=Query(2*node+1,mid+1,r,L,R);
    }
    return ret;
}

void Solve(){
    int N; cin>>N;
    for(int i=1;i<=N;i++){
        cin>>a[i];
    }
    Init(1,1,N);
    int Q; cin>>Q;
    while(Q--){
        int l,r; cin>>l>>r;
        Node n;
        Node n1=Query(1,1,N,1,l-1);
        Node n2=Query(1,1,N,r+1,N);
        Merge2(n,n1,n2);
        if(l==1 && r==N) cout<<0<<endl;
        else cout<<n.s<<endl;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; t=1;
    //cin>>t;
    while(t--){
        Solve();
    }
    return 0;
}