#include <iostream>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

// Loops
#define FOR(n)              for(int i=0;i<n;i++)
#define FORJ(n)             for(int j=0;j<n;j++)
#define FORN(n,x)           for(int x=0;i<n;i++)
#define RFOR(n)             for(int i=n-1;i>=0;i--)
#define RFORN(n,x)          for(int x=n-1;x>=0;x--)
#define ODD_FOR(n)          for(int i=1;i<n;i+=2)
#define EVEN_FOR(n)         for(int i=2;i<n;i+=2)
#define FROM(n,m)           for(int i=n;i<m;i++)
#define FROMJ(n,m)          for(int j=n;j<m;j++)
#define RFROM(n,m)          for(int i=n-1;i>=m;i--)
#define RFROMJ(n,m)         for(int j=n-1;j>=m;j--)
#define STL_FOR(a)          for(auto i=a.begin();i!=a.end();i++)
#define STL_FORJ(a)         for(auto j=a.begin();j!=a.end();j++)
#define STL_FORN(a,x)       for(auto x=a.begin();x!=a.end();x++)
#define STL_FROM(a,n,m)     for(auto i=n;i!=m;i++)
#define STL_FROMJ(n,m)      for(auto j=n;j!=m;j++)
#define RSTL_FOR(a)         for(auto i=a.rbegin();i!=a.rend();i++)
#define RSTL_FORJ(a)        for(auto j=a.rbegin();j!=a.rend();j++)

// Types
#define ll             long long int
#define vec                   vector
#define veci             vector<int>
#define pb                 push_back
#define pf                push_front
#define fi                     first
#define se                    second
#define umap           unordered_map
#define ummap     unordered_multimap
#define mmap                multimap
#define mset                multiset
#define uset           unordered_set
#define umset     unordered_multiset
#define endl                    '\n'
#define all(a)    a.begin(), a.end()

// I/O
void read() {}
template<typename type, typename... types>
void read(type& arg, types&... args) { cin >> arg; read(args...); }

void write() { cout << endl; }
template<typename type, typename... types>
void write(type arg, types... args) { cout << arg << ' '; write(args...); }

#define dbg(x) cerr<<#x<<" = "<<x<<endl;

struct edgedist {
    int e, d;
};

struct graph {
    int n, m;
    list<int>* adj;

    graph(int n, int m) :
        n(n), m(m)
    {
        adj = new list<int>[n + 1];
    }
    //~graph() {delete[] adj;}

    void add_edge(int node, int edge) {
        adj[node].push_back(edge);
        adj[edge].push_back(node);
    }

    friend istream& operator>> (istream& in, graph& g) {
        int node, edge;
        for (int i = 0; i < g.m; i++) {
            in >> node >> edge;
            g.add_edge(node, edge);
        }
        return in;
    }
};

ll dp1[200000] = {};
ll dp2[200000] = {};

bool seen1[200000] = {};
bool seen2[200000] = {};

ll n;
ll last;

ll shortest_path(const vector<ll>& a, int i) {

    if (seen1[i]) return dp1[i];
    seen1[i] = true;

    if (i < 1) return 0;

    dp1[i] = min(shortest_path(a, i - 1), shortest_path(a, i - 2)) + a[i];
    return dp1[i];
}

ll shortest_path_r(const vector<ll>& a, int i) {

    if (seen2[i]) return dp2[i];
    seen2[i] = true;

    if (i > last) return 0;

    dp2[i] = min(shortest_path_r(a, i + 1), shortest_path_r(a, i + 2)) + a[i];
    return dp2[i];

}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    vector<ll> a(n+2);
    FROM(1, n+1) cin >> a[i];
    a[0] = 0;
    a[n+1] = 0;
    last = n;

    shortest_path(a, n + 1);
    shortest_path_r(a, 0);

    int q;
    cin >> q;

    int l, r;
    while (q--) {
        cin >> l >> r;

        ll fi_ans = min(dp1[l - 1], (l==1 ? 0:dp1[l - 2]) ) + dp2[r + 1];
        ll sec_ans = min(fi_ans, dp1[l - 1]) + (r==n ? 0:dp2[r + 2]);

        cout << min(fi_ans, sec_ans) << endl;
    }


}