#include <iostream>
#include <vector>

using namespace std;

int main() {
    // Input dimensions of the matrix and submatrices
    int N, M, K, L;
    cin >> N >> M >> K >> L;

    // Input array A
    vector<vector<int>> A(N, vector<int>(M));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < M; ++j) {
            cin >> A[i][j];
        }
    }

    int maxBeauty = 0;

    // Iterate over all possible submatrices
    for (int i = 0; i <= N - K; ++i) {
        for (int j = 0; j <= M - L; ++j) {
            int beauty = 0;

            // Calculate the sum of elements in the current submatrix
            for (int x = i; x < i + K; ++x) {
                for (int y = j; y < j + L; ++y) {
                    beauty += A[x][y];
                }
            }

            // Update the maximum beauty if the current submatrix has higher beauty
            maxBeauty += beauty;  // Fixed: accumulate the sum of beauties
        }
    }

    // Output the total sum of beauties
    cout << maxBeauty << endl;

    return 0;
}